/*
MIT License.
https://forums.wz2100.net

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

#include "strpie.h"



strpie::strpie(void)
{
	variable_is_only_for_wzstring_to_fixed = 0;
}
strpie::strpie(const char* s)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	data = s;
}
strpie::strpie(string tempstr)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	data = tempstr;
}
strpie::strpie(int a)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	data = to_string(a);
}
strpie::strpie(unsigned int a)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	data = to_string(a);
}
strpie::strpie(__int64 a)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	data = to_string(a);
}
strpie::strpie(unsigned __int64 a)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	data = to_string(a);
}
strpie::strpie(float a)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	if (size_fixed == 0)
	{
		data = data + to_string(a);
	}

	stringstream strmem;
	strmem << fixed << setprecision(size_fixed) << a;
	data = data + strmem.str();
}
strpie::strpie(double a)
{
	variable_is_only_for_wzstring_to_fixed = 0;
	if (size_fixed == 0)
	{
		data = data + to_string(a);
	}

	stringstream strmem;
	strmem << fixed << setprecision(size_fixed) << a;
	data = data + strmem.str();
}
strpie& strpie::operator= (string str)
{
	data = str;
	strpie f;
	return f;
}
strpie& strpie::operator= (int a)
{
	strpie c;
	data = to_string(a);
	return c;
}
strpie& strpie::operator= (unsigned int a)
{
	strpie c;
	data = to_string(a);
	return c;
}
strpie& strpie::operator= (__int64 a)
{
	strpie c;
	data = to_string(a);
	return c;
}
strpie&  strpie::operator= (unsigned __int64 a)
{
	strpie c;
	data = to_string(a);
	return c;
}
strpie& strpie::operator= (float a)
{
	strpie c;
	if (size_fixed == 0)
	{
		data = to_string(a);
	}
	else
	{
		stringstream strmem;
		strmem << fixed << setprecision(size_fixed) << a;
		data = strmem.str();
	}
	return c;
}
strpie& strpie::operator= (double a)
{
	strpie c;
	if (size_fixed == 0)
	{
		data = to_string(a);
	}
	else
	{
		stringstream strmem;
		strmem << fixed << setprecision(size_fixed) << a;
		data = strmem.str();
	}
	return c;
}

string& strpie::operator+ (const char* s)
{
	data = "" + data + string(s);
	return data;
}
string& strpie::operator+(string str)
{
	return data = "" + data + str;
}
string& strpie::operator+(int a)
{
	return data = data + to_string(a);
}
string& strpie::operator+(unsigned int a)
{
	return data = data + to_string(a);
}
string& strpie::operator+(__int64 a)
{
	return data = data + to_string(a);
}
string& strpie::operator+(unsigned __int64 a)
{
	return data = data + to_string(a);
}
string& strpie::operator+(float a)
{
	if (size_fixed == 0)
	{
		return data = data + to_string(a);
	}

	stringstream strmem;
	strmem << fixed << setprecision(size_fixed) << a;
	return data = data + strmem.str();
}
string& strpie::operator+(double a)
{
	if (size_fixed == 0)
	{
		return data = data + to_string(a);
	}

	stringstream strmem;
	strmem << fixed << setprecision(size_fixed) << a;
	return data = data + strmem.str();
}


bool strpie::readFile(const char* filename)
{
	std::ifstream filedata(filename);
	std::stringstream wss;
	wss << filedata.rdbuf();
	data = wss.str();
	return true;
}
bool strpie::writeFile(const char* filename)
{
	std::ofstream outFile(filename, std::ios::out | std::ios::binary);
	outFile.write(data.c_str(), data.length());
	outFile.close();
	return true;
}

bool strpie::isThereChar(char symbol)
{
	int x = 0;
	while (1)
	{
		if (data[x] == symbol)
		{
			return true;
		}
		x++;
		if (x == data.length()) break;
	}
	return false;
}

void strpie::NewLine()
{
	data = data + "\n";
}

ostream& operator<<(ostream& os, strpie mystr)
{
	string temp = string(mystr.c_str());
	return os << temp;
}

typename std::enable_if<!std::is_same<const char*, int>::value, std::string>::type
operator+ (string s, int i)
{
	return s + std::to_string(i);
}

typename std::enable_if<!std::is_same<int, const char*>::value, std::string>::type
operator+ (int i, string s)
{
	return  std::to_string(i) + s;
}

typename std::enable_if<!std::is_same<const char*, unsigned int>::value, std::string>::type
operator+ (string s, unsigned int i)
{
	return s + std::to_string(i);
}

typename std::enable_if<!std::is_same<unsigned int, const char*>::value, std::string>::type
operator+ (unsigned int i, string s)
{
	return  std::to_string(i) + s;
}

typename std::enable_if<!std::is_same<const char*, __int64>::value, std::string>::type
operator+ (string s, __int64 i)
{
	return s + std::to_string(i);
}

typename std::enable_if<!std::is_same<__int64, const char*>::value, std::string>::type
operator+ (__int64 i, string s)
{
	return  std::to_string(i) + s;
}

// unsigned __int64   const char* + unsigned __int64 and  unsigned __int64 + const char*
typename std::enable_if<!std::is_same<const char*, unsigned __int64>::value, std::string>::type
operator+ (string s, unsigned __int64 i)
{
	return s + std::to_string(i);
}

typename std::enable_if<!std::is_same<unsigned __int64, const char*>::value, std::string>::type
operator+ (unsigned __int64 i, string s)
{
	return  std::to_string(i) + s;
}

typename std::enable_if<!std::is_same<const char*, float>::value, std::string>::type
operator+ (string s, float a)
{

	return s + to_string(a);

//	stringstream strmem;
//	strmem << fixed << setprecision(0) << a;
//	return s + strmem.str();
}

typename std::enable_if<!std::is_same<float, const char*>::value, std::string>::type
operator+ (float a, string s)
{

	return to_string(a) + s;

//	stringstream strmem;
//	strmem << fixed << setprecision(0) << a;
//	return strmem.str() + s;
}

typename std::enable_if<!std::is_same<const char*, double>::value, std::string>::type
operator+ (string s, double a)
{

	return s + to_string(a);

//	stringstream strmem;
//	strmem << fixed << setprecision(0) << a;
//	return s + strmem.str();
}

typename std::enable_if<!std::is_same<double, const char*>::value, std::string>::type
operator+ (double a, string s)
{

	return to_string(a) + s;
	
	//stringstream strmem;
	//strmem << fixed << setprecision(0) << a;
	//return strmem.str() + s;
}

std::string operator""_(const char a[], size_t len)
{
	return std::string(a);
}

typename std::enable_if<!std::is_same<string, const char*>::value, std::string>::type
operator+ (string str, string strwz)
{
	return str.append(strwz);
}


strpie& strpie::operator+ (strpie& str)
{

	if (wzstring_count) { buffer = data;  wzstring_count = 0; }
	buffer = buffer + str;
	str = buffer;
	return str;
}

strpie& strpie::operator= (strpie& str)
{
	wzstring_count = 1;
	data = str.data;
	return str;
}

strpie& strpie::operator= (const char* str)
{
	data = str;
	strpie f;
	return f;
}
void strpie::toFixed(short size)
{
	size_fixed = size;
	variable_is_only_for_wzstring_to_fixed = size;
}
const char* strpie::c_str()
{
	return data.c_str();
}
int strpie::length()
{
	return data.length();
}
string  strpie::replace(string replace, string to)
{
	if (replace.empty()) return "";

	size_t start_pos = 0;
	while ((start_pos = data.find(replace, start_pos)) != std::string::npos)
	{
		data.replace(start_pos, replace.length(), to);
		start_pos += to.length();
	}
	return data;
}
string&  strpie::operator[] (int index)
{
	if (data.length() > index)
	{
		tempdata = string(1, data[index]);
		return tempdata;
	}
	tempdata = "undefined";
	return tempdata;
}
string strpie::charAt(int index)
{
	if (data.length() > index)
	{
		return string(1, data[index]);
	}
	return string("");// undefined");
}

